#!/bin/sh

#
# NOTES:
# This DAPL provider (libdaploscm.so) uses sockets to setup the IB
# RC QP's so there is a very high demand on sockets at times:
# 
# sysctl -w net.ipv4.tcp_max_syn_backlog=2048
# sysctl -w net.ipv4.tcp_max_syncookies=1
#


DAPL_HOME=/hpc/local/commercial/impi_fca/dapl
MPI_HOME=/hpc/local/commercial/impi_fca
IMB_EXE=/hpc/local/mpitests/intel/imb/imb-3.2/src/IMB-MPI1
FCA_HOME=/volt/miked/work/svn/hpc/dev/fca/trunk/Debug
source $MPI_HOME/intel64/bin/mpivars.sh

PPN=8
HOSTS="john11 john12 john13 john14 john15 john16 john17"


export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$FCA_HOME/lib"

# Enable debug prints
export I_MPI_DEBUG=3
export I_MPI_PERHOST=$PPN

# setup dapl
export DAT_OVERRIDE=$DAPL_HOME/dat.conf
export I_MPI_DAT_LIBRARY=$DAPL_HOME/libdat2.so

##################### Do not edit below this line #####################

NHOSTS=$(echo $HOSTS |sed -e "s/,/ /g"|wc -w)
NP=$(expr $PPN \* $NHOSTS)
FCA_HOME=$(cd `dirname $0`/..;pwd)

rm -f $PWD/mpd.hosts
for h in $HOSTS ;do
    echo $h >> $PWD/mpd.hosts
done

if [ "$1" == "fca" ]; then
        echo Using FCA
        export I_MPI_DAPL_COLLECTIVES=all
        export I_MPI_FABRICS=dapl
        export I_MPI_FALLBACK_DEVICE=off
        export MPI_OPT="-env fca_mpi_debug_level 3"
else
        echo Using Vanilla Intel MPI
        export I_MPI_DAPL_COLLECTIVES=0
        export I_MPI_FABRICS=shm:dapl
        export MPI_OPT=
fi

$MPI_HOME/intel64/bin/mpirun $MPI_OPT -n $NP $IMB_EXE -npmin $NP barrier bcast reduce allreduce allgather allgatherv

