#!/bin/sh

if [ "`whoami`" != "root" ]; then
	echo Must be root to run this program
	exit 1
fi

udev_file="/etc/udev/rules.d/90-ib.rules"

if [ ! -f $udev_file ]; then
	echo Warning: Unable to find udev configuration file $udev_file which is part of ofa_kernel rpm.
	echo Run /opt/mellanox/fca/scripts/udev-update.sh manually after package ofa_kernel installation.
	exit 2
fi


if grep '^KERNEL=="umad\*"' $udev_file | grep MODE > /dev/null 2>&1 ; then
	echo INFO: udev section is already updated
else
	echo INFO: updating ...
	sed -i -e '/^KERNEL=="umad\*"/s|$| MODE="0666" |' $udev_file
fi

cnt=`ls -1 /dev/infiniband/umad* 2>/dev/null | wc -l`
if [ $cnt -gt 0 ]; then
	chmod -f 0666 /dev/infiniband/umad*
fi
exit 0
