/**
 * Copyright (C) Voltaire Ltd. 2001-2010.  ALL RIGHTS RESERVED.
 * This software product is a proprietary product of Voltaire Ltd.
 * (the "Company") and all right, title, and interest and to the software product,
 * including all associated intellectual property rights, are and shall
 * remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 * $COPYRIGHT$
 * $HEADER$
 */

#ifndef __MPI_MOCK_H__
#define __MPI_MOCK_H__

#include <stdint.h>
#include <arpa/inet.h>

enum {
	DEBUG_NONE = 0,
	DEBUG_INFO = 1,
	DEBUG_DATA = 2
};


enum test_type {
	TEST_REDUCE,
	TEST_BARRIER,
	TEST_BCAST
};


struct options {
	const char *server_addr;        /* Server address */
	int         server_port;        /* Server port */

	int         rank;               /* Rank number */
	int         comm_size;          /* Communicator size */
	int         proc_idx;           /* Index of local process */
	int         num_procs;          /* Number of local processes */

	long        message_count;	/* Number of operations */
	long        print_interval;	/* Interval (in packets) of status print */
	
	enum test_type test_type;       /* Test type */
	double	    data;
	double      result;
	int         verify;
	int         vec_size;
	
	fca_init_spec_t *fca_spec;
};


int parse_options(int argc, char **argv, char **envp, struct options *options);

#endif
